<?php
/**
 * Global Settings
 *
 * @package  Good_market_woocommerce
 * @version  1.0.0
 * @link     https://cedcommerce.com
 * @since    1.0.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	die;
}

get_good_market_header();

$current_tab = isset( $_GET['section'] ) ? sanitize_text_field( $_GET['section'] ) : 'product-specific';

?>

<div class="ced_good_market_global_field_wrapper">
    <div class="ced_good_market_global_field_content">
        <div class="ced_good_market_global_field_header">
            <ul>
            <li>
                <a href="<?php echo esc_url( admin_url( 'admin.php?page=ced_good_market&section=global_settings' ) ); ?>" id="product-specific" class="
                                    <?php
                                    if ( 'product-specific' == $current_tab ) {
                                        echo 'active'; }
                                    ?>
                "><?php esc_html_e( 'Product', 'good_market-woocommerce-integration' ); ?></a>
            </li>
            <li>
                <a href="<?php echo esc_url( admin_url( 'admin.php?page=ced_good_market&section=global_settings&tab=order-specific' ) ); ?>" id="order-specific" class="
                                    <?php
                                    if ( 'order-specific' == $current_tab ) {
                                        echo 'active'; }
                                    ?>
                "><?php esc_html_e( 'Order', 'good_market-woocommerce-integration' ); ?></a>
            </li>
            <li>
                <a href="<?php echo esc_url( admin_url( 'admin.php?page=ced_good_market&section=global_settings&tab=sync-specific' ) ); ?>" id="sync-specific" class="
                                    <?php
                                    if ( 'sync-specific' == $current_tab ) {
                                        echo 'active'; }
                                    ?>
                "><?php esc_html_e( 'Crons', 'good_market-woocommerce-integration' ); ?></a>
            </li> 
        </ul>
        </div>
    </div>
    <div>
        <div class="ced_good_market_global_product_field_wrapper">
            
            <?php
            if ( 'global' == $current_tab ) {
                include_once GOOD_MARKET_WOOCOMMERCE_DIRPATH . 'admin/pages/ced-good_market-global-product-fields.php';
            }
            ?>
        </div>
        <div>
            <?php
            if ( 'order-specific' == $current_tab ) {
                include_once GOOD_MARKET_WOOCOMMERCE_DIRPATH . 'admin/pages/ced-good_market-global-order-fields.php';
            }
            ?>
        </div>
        <div>
            <?php
            if ( 'sync-specific' == $current_tab ) {
                include_once GOOD_MARKET_WOOCOMMERCE_DIRPATH . 'admin/pages/ced-good_market-global-sync-fields.php';
            }
            ?>
        </div>
    </div>
</div>
