<?php

/**
 * The plugin bootstrap file
 *
 * This file is read by WordPress to generate the plugin information in the plugin
 * admin area. This file also includes all of the dependencies used by the plugin,
 * registers the activation and deactivation functions, and defines a function
 * that starts the plugin.
 *
 * @link              https://cedcommerce.com
 * @since             1.0.0
 * @package           Good_market_woocommerce
 *
 * @wordpress-plugin
 * Plugin Name:       Good Market WooCommerce Integration
 * Plugin URI:        https://cedcommerce.com
 * Description:       This is a short description of what the plugin does. It's displayed in the WordPress admin area.
 * Version:           1.0.0
 * Author:            CedCommerce
 * Author URI:        https://cedcommerce.com
 * License:           GPL-2.0+
 * License URI:       http://www.gnu.org/licenses/gpl-2.0.txt
 * Text Domain:       good_market_woocommerce
 * Domain Path:       /languages
 */

// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die;
}

/**
 * Currently plugin version.
 * Start at version 1.0.0 and use SemVer - https://semver.org
 * Rename this for your plugin and update it as you release new versions.
 */
define( 'GOOD_MARKET_WOOCOMMERCE_VERSION', '1.0.0' );
define( 'GOOD_MARKET_WOOCOMMERCE_DIRPATH', plugin_dir_path( __FILE__ ) );
define( 'GOOD_MARKET_WOOCOMMERCE_URL', plugin_dir_url( __FILE__ ) );

require GOOD_MARKET_WOOCOMMERCE_DIRPATH . '/includes/ced-good-market-core.php';

/**
 * The code that runs during plugin activation.
 * This action is documented in includes/class-good_market_woocommerce-activator.php
 */
function activate_good_market_woocommerce() {
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-good_market_woocommerce-activator.php';
	Good_market_woocommerce_Activator::activate();
}

/**
 * The code that runs during plugin deactivation.
 * This action is documented in includes/class-good_market_woocommerce-deactivator.php
 */
function deactivate_good_market_woocommerce() {
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-good_market_woocommerce-deactivator.php';
	Good_market_woocommerce_Deactivator::deactivate();
}

register_activation_hook( __FILE__, 'activate_good_market_woocommerce' );
register_deactivation_hook( __FILE__, 'deactivate_good_market_woocommerce' );

/**
 * The core plugin class that is used to define internationalization,
 * admin-specific hooks, and public-facing site hooks.
 */
require plugin_dir_path( __FILE__ ) . 'includes/class-good_market_woocommerce.php';

/**
 * Begins execution of the plugin.
 *
 * Since everything within the plugin is registered via hooks,
 * then kicking off the plugin from this point in the file does
 * not affect the page life cycle.
 *
 * @since    1.0.0
 */
function run_good_market_woocommerce() {

	$plugin = new Good_market_woocommerce();
	$plugin->run();

}
run_good_market_woocommerce();
