<?php

/**
 * Fired during plugin deactivation
 *
 * @link       https://cedcommerce.com
 * @since      1.0.0
 *
 * @package    Good_market_woocommerce
 * @subpackage Good_market_woocommerce/includes
 */

/**
 * Fired during plugin deactivation.
 *
 * This class defines all code necessary to run during the plugin's deactivation.
 *
 * @since      1.0.0
 * @package    Good_market_woocommerce
 * @subpackage Good_market_woocommerce/includes
 * @author     CedCommerce <plugins@cedcommerce.com>
 */
class Good_market_woocommerce_Deactivator {

	/**
	 * Short Description. (use period)
	 *
	 * Long Description.
	 *
	 * @since    1.0.0
	 */
	public static function deactivate() {
        self::disable_goodmarket_upload_feed_status_schedule();
	}
    private static function disable_goodmarket_upload_feed_status_schedule() {
        wp_clear_scheduled_hook( 'sync_good_market_feeds' );
    }

}